<?php

/*
  Plugin Name: Webislife news
  Plugin URI: http://webislife.ru
  Description: Виджет вывода постов из разных категорий
  Author: Webislife
  Author URI: http://webislife.ru
  Version: 1.2
 */

function wil_get_post() {
    
}

function wil_news($args) {

    extract($args);

    echo $before_widget;
    echo $before_title;
    echo get_option('wil_widget_title');
    echo $after_title;
    global $wpdb;
    $sql = "SELECT a.post_content,a.post_title,a.guid,a.ID AS uID,a.post_date,a.post_author,b.term_taxonomy_id,c.ID,c.display_name FROM " . $wpdb->posts . " a," . $wpdb->term_relationships . " b," . $wpdb->users . " c WHERE a.ID=b.object_id AND b.term_taxonomy_id='" . get_option('wil_cat_id') . "' AND a.post_status='publish' AND a.post_type='post' AND a.post_author=c.ID ORDER BY ID " . get_option('wil_widget_ASC') . " LIMIT 0," . get_option('wil_widget_post_count');
    $result = $wpdb->get_results($sql, ARRAY_A);
    foreach ($result as $post) {
        $wil_post = mb_substr(strip_tags($post['post_content']), 0, get_option('wil_widget_symbol'));
        echo '<h4 class="wil_post_link"><a href="' . $post['guid'] . '">' . $post['post_title'] . '</a></h4>';
        if (get_option('wil_widget_date_position') == 'top') {
                echo '<span class="wil_date">'.date_format(date_create($post['post_date']), get_option('wil_widget_date')).'</span>';
            
        }
        if (get_option('wil_widget_author_position') == 'top') {
                echo get_option('wil_widget_author') .' <span class="wil_author">'.$post['display_name'].'</span>';
            
        }
        echo '<p class="wil_post_content">' . $wil_post;
        if (mb_strlen($post['post_content']) > mb_strlen($wil_post)) {
            echo ' <a href="' . $post['guid'] . '">' . get_option('wil_widget_more') . '</a>';
        };
        echo '</p>';
        if (get_option('wil_widget_date_position') == 'down') {
                echo '<span class="wil_date">'.date_format(date_create($post['post_date']), get_option('wil_widget_date')).'</span>';
        }
        if (get_option('wil_widget_author_position') == 'down') {
                echo get_option('wil_widget_author') .' <span class="wil_author">'.$post['display_name'].'</span>';
            
        }
        $wil_post = NULL;
    }
    echo $after_widget;
}

function register_my_widget() {
    register_sidebar_widget('Webislife news', 'wil_news');
    register_widget_control('Webislife news', 'wil_widget_control');
}

function wil_widget_control() {
#Title
    if (!empty($_REQUEST['wil_widget_title'])) {
        update_option('wil_widget_title', $_REQUEST['wil_widget_title']);
    }
    echo 'Заголовок:<br /><input type="text" name="wil_widget_title" value="' . get_option('wil_widget_title') . '" /><br />';
#Category
    global $wpdb;
    $sql = 'SELECT tt.term_id, tt.taxonomy, t.name, t.term_id FROM ' . $wpdb->term_taxonomy . ' tt, ' . $wpdb->terms . ' t WHERE tt.taxonomy = "category" AND t.term_id = tt.term_id';
    $result = $wpdb->get_results($sql, ARRAY_A);
    if (!empty($_REQUEST['wil_cat_id'])) {
        update_option('wil_cat_id', $_REQUEST['wil_cat_id']);
    }
    echo 'Выберите рубрику:<br />
        <select name="wil_cat_id">';
    foreach ($result as $cat) {
        echo '<option value="' . $cat['term_id'] . '"';
        if ($cat['term_id'] == get_option('wil_cat_id'))
            echo 'selected';
        echo '>' . $cat['name'] . '</option>';
    }
    echo '</select><br />';
#Post count
    if (!empty($_REQUEST['wil_widget_post_count'])) {
        update_option('wil_widget_post_count', $_REQUEST['wil_widget_post_count']);
    }
    echo 'Сколько записей выводить?<br /><input type="text" name="wil_widget_post_count" value="' . get_option('wil_widget_post_count') . '" /><br />';
#Symbol per post
    if (!empty($_REQUEST['wil_widget_symbol'])) {
        update_option('wil_widget_symbol', $_REQUEST['wil_widget_symbol']);
    }
    echo 'Сколько символов выводить?<br /><input type="text" name="wil_widget_symbol" value="' . get_option('wil_widget_symbol') . '" /><br />';
#More link text
    if (!empty($_REQUEST['wil_widget_more'])) {
        update_option('wil_widget_more', $_REQUEST['wil_widget_more']);
    }
    echo 'Текст подробнее:<br /><input type="text" name="wil_widget_more" value="' . get_option('wil_widget_more') . '" /><br />';
#ASC or DESC
    if (!empty($_REQUEST['wil_widget_ASC'])) {
        update_option('wil_widget_ASC', $_REQUEST['wil_widget_ASC']);
    }
    echo 'Первыми выводить?<br />
        Старые <input type="radio" name="wil_widget_ASC"';
    if (get_option('wil_widget_ASC') == 'ASC')
        echo 'checked';
    echo ' value="ASC"/>
        Новые <input type="radio" name="wil_widget_ASC"';
    if (get_option('wil_widget_ASC') == 'DESC')
        echo 'checked';
    echo ' value="DESC"/>        
        <br />';
#date format
    if (!empty($_REQUEST['wil_widget_date'])) {
        update_option('wil_widget_date', $_REQUEST['wil_widget_date']);
    }
    echo 'Формат даты (<a href="http://www.php.su/functions/?date" target="_blank">PHP</a>)<input type="text" name="wil_widget_date" value="' . get_option('wil_widget_date') . '" /><br />';
#date positions
    if (!empty($_REQUEST['wil_widget_date_position'])) {
        update_option('wil_widget_date_position', $_REQUEST['wil_widget_date_position']);
    }
    echo 'Отображать дату:<br />
        Сверху <input type="radio" name="wil_widget_date_position"';
    if (get_option('wil_widget_date_position') == 'top')
        echo 'checked';
    echo ' value="top"/>
        Снизу <input type="radio" name="wil_widget_date_position"';
    if (get_option('wil_widget_date_position') == 'down')
        echo 'checked';
    echo ' value="down"/>    
        Не отображать <input type="radio" name="wil_widget_date_position"';
    if (get_option('wil_widget_date_position') == 'NOT')
        echo 'checked';
    echo ' value="NOT"/>
        <br />';
#Author format
    if (!empty($_REQUEST['wil_widget_author'])) {
        update_option('wil_widget_author', $_REQUEST['wil_widget_author']);
    }
    echo 'Заголовок автора:<br /><input type="text" name="wil_widget_author" value="' . get_option('wil_widget_author') . '" /><br />';
#Author position
    if (!empty($_REQUEST['wil_widget_author_position'])) {
        update_option('wil_widget_author_position', $_REQUEST['wil_widget_author_position']);
    }
    echo 'Отображать автора:<br />
        Сверху <input type="radio" name="wil_widget_author_position"';
    if (get_option('wil_widget_author_position') == 'top')
        echo 'checked';
    echo ' value="top"/>
        Снизу <input type="radio" name="wil_widget_author_position"';
    if (get_option('wil_widget_author_position') == 'down')
        echo 'checked';
    echo ' value="down"/>    
        Не отображать <input type="radio" name="wil_widget_author_position"';
    if (get_option('wil_widget_author_position') == 'NOT')
        echo 'checked';
    echo ' value="NOT"/>
        <br />';

}

add_action('init', 'register_my_widget');
?>